Index: apps/app_voicemail.c
===================================================================
--- apps/app_voicemail.c	(revision 50404)
+++ apps/app_voicemail.c	(working copy)
@@ -4651,7 +4651,8 @@
 #ifdef IMAP_STORAGE
 static void imap_mailbox_name(char *spec, struct vm_state *vms, int box, int use_folder)
 {
-	char tmp[256];
+	char tmp[256], *t=tmp;
+	int tmax = sizeof(tmp);
 	
 	if (box == 1) {
 		ast_copy_string(vms->curbox, mbox(0), sizeof(vms->curbox));
@@ -4661,11 +4662,17 @@
 		snprintf(vms->vmbox, sizeof(vms->vmbox), "vm-%s", vms->curbox);
 	}
 
-	if (strlen(authuser) > 0) {
-		snprintf(tmp, sizeof(tmp), "{%s:%s/imap/authuser=%s/%s/user=%s}",imapserver,imapport,authuser,imapflags,vms->imapuser);
-	} else {
-		snprintf(tmp, sizeof(tmp), "{%s:%s/imap/%s/user=%s}",imapserver,imapport,imapflags,vms->imapuser);
-	}
+	/* build up the folder specification string */
+	ast_build_string(&t, &tmax, "{%s:%s/imap", imapserver, imapport);
+
+	if (!ast_strlen_zero(authuser))
+		ast_build_string(&t, &tmax, "/%s", authuser);
+
+	if(!ast_strlen_zero(imapflags))
+		ast_build_string(&t, &tmax, "/%s", imapflags);
+
+	ast_build_string(&t, &tmax, "/user=%s}", vms->imapuser);
+
 	if(box == 0 || box == 1)
 		sprintf(spec, "%s%s", tmp, use_folder? imapfolder: "INBOX");
 	else
